package ballerina.lang.exceptions;

@doc:Description ("Sets cause of the specified exception")
@doc:Param ("e: The exception object" )
@doc:Param ("cause: The exception cause to be added" )
native function setCause (exception e, exception cause);

@doc:Description ("Set the message and the category.")
@doc:Param ("e: The exception object" )
@doc:Param ("message: The exception message to be added" )
@doc:Param ("category: The exception category to be added" )
native function set (exception e, string m, string category);

@doc:Description ("Gets the category of an exception")
@doc:Param ("e: The exception object" )
@doc:Return ("string): The exception category" )
native function getCategory (exception e) (string);

@doc:Description ("Gets the exception stack trace with the cause ")
@doc:Param ("e: The exception object" )
@doc:Return ("string) : The exception stacktrace" )
native function getStackTrace (exception e) (string);

@doc:Description ("Set the category of an exception.")
@doc:Param ("e: The exception object" )
@doc:Param ("category: The exception category to be added" )
native function setCategory (exception e, string category);

@doc:Description ("Sets exception message specified exception")
@doc:Param ("e: The exception object" )
@doc:Param ("message: The exception message to be added" )
native function setMessage (exception e, string m);

@doc:Description ("Set message to an exception.")
@doc:Param ("e: The exception object" )
@doc:Return ("string): The exception message" )
native function getMessage (exception e) (string);

